<template>
  <div class="mb-2">
    <label :for="fieldPrefix + field.name" v-if="field.label">
      {{ field.label }}
      <RequiredIcon v-if="isRequired" />
      <InfoTooltip v-if="field.tooltip" :text="field.tooltip" />
    </label>
    <div class="input-group">
      <div class="input-group-prepend" v-if="field.iconClass">
        <span class="input-group-text">
          <i :class="field.iconClass"></i>
        </span>
      </div>
      <input
        :type="field.type"
        :id="fieldPrefix + field.name"
        :class="['form-control', { 'border-danger': hasError }]"
        :placeholder="field.placeholder"
        :maxlength="field.maxlength"
        v-model="fieldValue"
        @input="onInput"
        @keyup.enter="onSubmit"
        :aria-label="field.label"
        :disabled="field.disabled || busy"
      />
      <div class="input-group-append" v-if="field.buttonText || field.buttonIconClass">
        <button class="btn btn-primary" type="button" @click="onButton">
          <i aria-hidden="true" :class="field.buttonIconClass"></i>
          <span>{{ field.buttonText }}</span>
        </button>
      </div>
    </div>
    <div class="text-danger" v-if="error">{{ error }}</div>
  </div>
</template>

<script>
import { useVFormControl } from '../../plugins/vform-plugin.js'
import InfoTooltip from '../info-tooltip.vue'
import RequiredIcon from '../required-icon.vue'

export default {
  name: 'VFormText',
  props: {
    formName: { type: String, required: true },
    field: { type: Object, required: true },
    fieldPrefix: { type: String, required: true },
    modelState: { type: Object, default: null }, // Taken from the API response if validation fails at the server.
    busy: { type: Boolean, default: false },
  },
  components: {
    InfoTooltip,
    RequiredIcon,
  },
  setup(props, context) {
    return useVFormControl(props, context)
  },
}
</script>
